/* Copyright (c) 2005, David A. Clunie DBA Pixelmed Publishing. All rights reserved. */

package com.pixelmed.ucum;

import antlr.collections.AST;

public class UCUMCanonicalStructure {
	double constant;
	AST numerator;
	AST denominator;
		
	UCUMCanonicalStructure(double constant,AST numerator,AST denominator) {
		this.constant=constant;
		this.numerator=numerator;
		this.denominator=denominator;
	}
		
	public String toString() {
		return "( / ( . "
		      +constant
		      +" "
		      +(numerator == null ? "null" : numerator.toStringList())
		      +" ) ( . "
		      +(denominator == null ? "null" : denominator.toStringList())
		      +" ) )"
		      ; 
	}
	
	public boolean equalsApartFromConstant(UCUMCanonicalStructure ucs2) {
		return ucs2 != null
		    && (this.numerator == null   && ucs2.numerator == null   || (this.numerator != null   && ucs2.numerator != null   && this.numerator.equalsList(ucs2.numerator)))
		    && (this.denominator == null && ucs2.denominator == null || (this.denominator != null && ucs2.denominator != null && this.denominator.equalsList(ucs2.denominator)))
		    ;
	}
	
	public double getConstant() { return constant; }
}

